! chuck-scl.cmd
! Create a ChucK source file using tuning data from scale memory
! It creates functions that return a frequency from a scale degree or
! note name and an octave number.
! There is one parameter: the filename to be written.
!
! ChucK, created by Ge Wang and Perry Cook is a freeware cross-platform 
! interactive programming language for music.
! Software for Windows, Linux and OS X at http://chuck.cs.princeton.edu
!
! To create a MIDI based tuning table, use
! SET SYNTH 130
! SEND/FILE myscale.ck
!
ECHO Create a ChucK source file using tuning data from scale memory
set pause off
file 'p1'
echo // ChucK scale functions created by Scala
echo
echo class Scala_Functions
echo {
echo // %desc(0)
echo [ 1.0,
iterate/scale "echo %factor($1)," 0 n-1
echo %factor(%n) ] @=> float scale[];
echo
echo %n(0) => int extent;
echo  scale[extent] => float octave;
echo %hertz(1) => float base;
echo
echo // %sys()
echo  1.0 => scale["%note(1)"];
iterate/scale "echo %factor($1) => scale["%note($1)"];" 0 n-1
echo
echo fun float deg_to_freq (int deg, int oct)
echo {
echo    return base * (scale[deg%extent] + (oct + deg/extent) * octave);
echo }
echo
echo fun float name_to_freq (string nam, int oct)
echo {
echo    return base * (scale[nam] + oct * octave);
echo }
echo } // end Scala_Functions
close
